Bug 894603

Summary: Review Request: coin-or-FlopC++ - Algebraic modelling language
Product: [Fedora] Fedora Reporter: Paulo Andrade <paulo.cesar.pereira.de.andrade>
Component: Package ReviewAssignee: Antonio Trande <anto.trande>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: package-review
Target Milestone: ---Flags: anto.trande: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: coin-or-Cbc-2.9.2-5.fc22 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-03-09 04:25:28 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 894585, 894586, 894587, 894588, 894597    
Bug Blocks:    

Description Paulo Andrade 2013-01-12 10:29:29 EST
Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++-1.1.2-3.fc19.src.rpm
Description: An open source algebraic modelling language implemented as a C++ class
library.

Using FLOPC++, linear optimization models can be specified in a declarative
style, similar to algebraic modelling languages such as GAMS and AMPL,
within a C++ program. As a result the traditional strengths of algebraic
modelling languages are preserved, while embedding linear optimization
models in software applications is facilitated.

FLOPC++ can be used as a substitute for traditional modelling languages,
when modelling linear optimization problems, but its principal strength
lies in the fact that the modelling facilities are combined with a
powerful general purpose programming language. This combination is
essential for implementing efficient algorithms (using linear optimization
for subproblems), integrating optimization models in user applications, etc.
Fedora Account System Username: pcpa
Comment 1 Paulo Andrade 2013-01-12 10:30:49 EST
Note that the tarball is remade due to:
+ Data files without a clean license. licensecheck does not trigger
  it because they are small test case files, but a not so small
  collection, and authorship information was lost.
+ ThirdParty directory, that points to, but has no contents, of
  non free code (usually source code open but needs some kind of
  paid license to be able to use).
+ Most coin-or projects bundle other coin-or projects that are
  dependencies. If tarballs are not repackaged, %build will remove
  the bundled dependencies.

I made the original package back in september and was talking from
time to time to upstream about the issues above. There should be
at some point in the near future a new release with bundled dependencies
and code that cannot be redistributed removed from tarballs. There is
also a way to get "clean" tarballs from coin-or trac, but for the
review request I did choose the most common method in Fedora for
these conditions.
Comment 2 Paulo Andrade 2013-01-14 17:09:34 EST
Update:

- Update to run make check (#894610#c4).

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++-1.1.2-4.fc19.src.rpm
Comment 3 Antonio Trande 2014-09-18 14:37:41 EDT
'make tests' fails on rawhide:

...
/usr/bin/ld: cannot find -lbz2
/usr/bin/ld: cannot find -lz
collect2: error: ld returned 1 exit status
Comment 4 Paulo Andrade 2015-02-28 16:33:22 EST
Updated to use latest upstream tarball and package build corrections.

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++-1.1.7-3.fc23.src.rpm
Comment 5 Antonio Trande 2015-03-01 07:45:44 EST
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s) in
  its own file, then that file, containing the text of the license(s) for the
  package is included in %doc.
  Note: Cannot find LICENSE in rpm(s)
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 58 files have unknown license. Detailed output of
     licensecheck in /home/sagitter/894603-coin-or-FlopC++/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
     Note: Test run failed
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Test run failed
[x]: Packages must not store files under /srv, /opt or /usr/local
     Note: Test run failed
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Test run failed
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: coin-or-FlopC++-1.1.7-3.fc23.x86_64.rpm
          coin-or-FlopC++-devel-1.1.7-3.fc23.x86_64.rpm
          coin-or-FlopC++-1.1.7-3.fc23.src.rpm
coin-or-FlopC++.x86_64: W: spelling-error Summary(en_US) modelling -> modeling, model ling, model-ling
coin-or-FlopC++.x86_64: W: spelling-error %description -l en_US modelling -> modeling, model ling, model-ling
coin-or-FlopC++.x86_64: W: spelling-error %description -l en_US subproblems -> sub problems, sub-problems, problems
coin-or-FlopC++.x86_64: W: invalid-url URL: http://projects.coin-or.org/FlopCpp HTTP Error 404: Not Found
coin-or-FlopC++.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/coin-or-FlopC++/README
coin-or-FlopC++-devel.x86_64: W: invalid-url URL: http://projects.coin-or.org/FlopCpp HTTP Error 404: Not Found
coin-or-FlopC++-devel.x86_64: W: only-non-binary-in-usr-lib
coin-or-FlopC++-devel.x86_64: W: no-documentation
coin-or-FlopC++.src: W: spelling-error Summary(en_US) modelling -> modeling, model ling, model-ling
coin-or-FlopC++.src: W: spelling-error %description -l en_US modelling -> modeling, model ling, model-ling
coin-or-FlopC++.src: W: spelling-error %description -l en_US subproblems -> sub problems, sub-problems, problems
coin-or-FlopC++.src: W: invalid-url URL: http://projects.coin-or.org/FlopCpp HTTP Error 404: Not Found
3 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Diff spec file in url and in SRPM
---------------------------------
--- /home/sagitter/894603-coin-or-FlopC++/srpm/coin-or-FlopC++.spec	2015-03-01 12:36:07.146604800 +0100
+++ /home/sagitter/894603-coin-or-FlopC++/srpm-unpacked/coin-or-FlopC++.spec	2015-02-28 22:16:24.000000000 +0100
@@ -8,5 +8,5 @@
 Release:	3%{?dist}
 License:	EPL
-URL:		http://www.coin-or.org/projects/%{project}.xml
+URL:		http://projects.coin-or.org/%{module}
 Source0:	http://www.coin-or.org/download/pkgsource/%{project}/%{module}-%{version}.tgz
 BuildRequires:	atlas-devel


Requires
--------
coin-or-FlopC++-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    coin-or-CoinUtils-devel
    coin-or-FlopC++(x86-64)
    pkgconfig(osi)

coin-or-FlopC++ (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.1)(64bit)
    rtld(GNU_HASH)



Provides
--------
coin-or-FlopC++-devel:
    coin-or-FlopC++-devel
    coin-or-FlopC++-devel(x86-64)
    pkgconfig(flopcpp)

coin-or-FlopC++:
    coin-or-FlopC++
    coin-or-FlopC++(x86-64)
    libFlopCpp.so.0()(64bit)



Source checksums
----------------
http://www.coin-or.org/download/pkgsource/FlopC++/FlopCpp-1.1.7.tgz :
  CHECKSUM(SHA256) this package     : dbe3a52d1a0203acc44da38cb0f9cf2a5314d58257f7a7a83843944dd6c5d928
  CHECKSUM(SHA256) upstream package : dbe3a52d1a0203acc44da38cb0f9cf2a5314d58257f7a7a83843944dd6c5d928


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 894603
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 6 Paulo Andrade 2015-03-01 08:51:11 EST
Thanks! Update:

- Correct package URL (#894603#c5)
- Correct line endings of the README file (#894603#c5)

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-FlopC++-1.1.7-4.fc23.src.rpm
Comment 7 Antonio Trande 2015-03-01 08:59:58 EST
Package approved.
Comment 8 Paulo Andrade 2015-03-01 09:03:06 EST
New Package SCM Request
=======================
Package Name: coin-or-FlopC++
Short Description: Algebraic modelling language
Upstream URL: http://www.coin-or.org/projects/FlopC++.xml
Owners: pcpa
Branches: f22
InitialCC:
Comment 9 Gwyn Ciesla 2015-03-01 11:48:50 EST
Git done (by process-git-requests).
Comment 10 Fedora Update System 2015-03-01 14:49:17 EST
coin-or-Cbc-2.9.2-5.fc22,coin-or-Ipopt-3.12.1-4.fc22,coin-or-Bonmin-1.8.1-3.fc22,coin-or-SYMPHONY-5.6.8-1.fc22,coin-or-FlopC++-1.1.7-4.fc22,coin-or-Couenne-0.5.2-3.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/coin-or-Cbc-2.9.2-5.fc22,coin-or-Ipopt-3.12.1-4.fc22,coin-or-Bonmin-1.8.1-3.fc22,coin-or-SYMPHONY-5.6.8-1.fc22,coin-or-FlopC++-1.1.7-4.fc22,coin-or-Couenne-0.5.2-3.fc22
Comment 11 Fedora Update System 2015-03-02 18:06:46 EST
Package coin-or-Cbc-2.9.2-5.fc22, coin-or-Ipopt-3.12.1-4.fc22, coin-or-Bonmin-1.8.1-3.fc22, coin-or-SYMPHONY-5.6.8-1.fc22, coin-or-FlopC++-1.1.7-4.fc22, coin-or-Couenne-0.5.2-3.fc22:
* should fix your issue,
* was pushed to the Fedora 22 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing coin-or-Cbc-2.9.2-5.fc22 coin-or-Ipopt-3.12.1-4.fc22 coin-or-Bonmin-1.8.1-3.fc22 coin-or-SYMPHONY-5.6.8-1.fc22 coin-or-FlopC++-1.1.7-4.fc22 coin-or-Couenne-0.5.2-3.fc22'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-2915/coin-or-Cbc-2.9.2-5.fc22,coin-or-Ipopt-3.12.1-4.fc22,coin-or-Bonmin-1.8.1-3.fc22,coin-or-SYMPHONY-5.6.8-1.fc22,coin-or-FlopC++-1.1.7-4.fc22,coin-or-Couenne-0.5.2-3.fc22
then log in and leave karma (feedback).
Comment 12 Fedora Update System 2015-03-09 04:25:28 EDT
coin-or-Cbc-2.9.2-5.fc22, coin-or-Ipopt-3.12.1-4.fc22, coin-or-Bonmin-1.8.1-3.fc22, coin-or-SYMPHONY-5.6.8-1.fc22, coin-or-FlopC++-1.1.7-4.fc22, coin-or-Couenne-0.5.2-3.fc22 has been pushed to the Fedora 22 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Paulo Andrade 2015-06-14 18:48:47 EDT
Package Change Request
======================
Package Name: coin-or-FlopC++
New Branches: f21
Owners: pcpa
InitialCC: pcpa

Update coin-or stack.
Comment 14 Gwyn Ciesla 2015-06-15 08:49:50 EDT
Git done (by process-git-requests).